%
% Vytvorenie GUI okna
% Tatiana Lipnicanova
% marec 2004
%
clear
global Stime q0s q0 k11 k22 F1 F2 h1s h2s A B C D intr bg my

% the default values of the parameters
Stime = 0;
q0s = 1.00;
q0 = 1.10;
k11 = 0.8;
k22 = 0.5;
F1 = 0.8;
F2 = 0.8;
intr = 0;
% the heights of water levels of the tanks without interaction for default values
h1s = 2.04;
h2s = 1.23;
% ---------------------------------------------------------------
% examine if animation window already is open
if ~isempty(findobj('Name', 'Two tanks system'))
    close('Two tanks system');
end
% ---------------------------------------------------------------
 my.objHandl(1) = figure('Color',[0.75 0.75 0.75], ...
    'MenuBar','none', ...
    'Name','Two tanks system', ...
    'NumberTitle', 'off', ...
	'PaperPosition',[18 180 576 432], ...
	'PaperUnits','points', ...
    'Position',[300 20 600 700], ...
    'Resize', 'off', ...
    'DoubleBuffer', 'on', ...
	'ToolBar','none');

% animation axis
 my.objHandl(2) = axes('Parent',my.objHandl(1),...
    'Box','on', ...
    'Color',[1 1 1], ...
    'Layer', 'top', ...
	'NextPlot','add', ...
	'Position',[0.05 0.42 0.55 0.55], ...
    'Tag','picture', ...
    'TickDir','out', ...
    'Visible','on', ...
    'XColor',[0.75 0.75 0.75],...
    'XLim',[-50 1550], ...
    'YColor',[0.75 0.75 0.75], ...
    'YLim',[-50 1200]);

% graph axis
my.objHandl(3) = axes('Parent',my.objHandl(1),...
    'Box','on', ...
    'Color',[1 1 1], ...
	'NextPlot','add', ...
	'Position',[0.0850 0.0671 0.3768 0.2871], ...
    'Tag','graphL', ...
    'Visible','on', ...
    'XLim',[0 5], ...
    'YLim',[0 3]);
text('Parent', my.objHandl(3),...
    'FontSize', 11, ...
    'HandleVisibility', 'off', ...
    'Units','points', ...
    'Position',[85 165 0], ...
    'HorizontalAlignment','center', ...
    'String', 'Step Response');
text('Parent', my.objHandl(3),...
    'FontSize', 9.5, ...
    'Units','points', ...
    'Position',[85 -20 0], ...
    'HorizontalAlignment','center', ...
    'String', 'time [s]');
text('Parent', my.objHandl(3),...
    'FontSize', 9.5, ...
    'Units','points', ...
    'Position',[-25 80 0], ...
    'HorizontalAlignment','center', ...
    'Rotation', 90, ...
    'String', 'h1(t), h2(t) [m]');
%%%%%
my.objHandl(4) = uicontrol('Parent',my.objHandl(1), ...
	'Units','points', ...
    'BackgroundColor',[0.75 0.75 0.75], ...
    'Callback','guifcn(1,my.objHandl(14))',...
	'Position',[288.75 434.25 81.75 15.75], ...
    'FontSize',10, ...
	'String','with interaction', ...
	'Style','checkbox', ...
    'Tag','Checkbox1', ...
    'Value',0);
my.objHandl(5) = uicontrol('Parent',my.objHandl(1), ...
	'Units','points', ...
    'BackgroundColor',[1 1 1], ...
  	'Callback','guifcn(3,[my.objHandl(5) my.objHandl(14)])',...
	'Position',[378.75 409.5 45 15], ...
	'String',k11, ...
	'Style','edit', ...
	'Tag','EditText2');
my.objHandl(6) = uicontrol('Parent',my.objHandl(1), ...
	'Units','points', ...
    'BackgroundColor',[1 1 1], ...
  	'Callback','guifcn(3,[my.objHandl(6) my.objHandl(14)])',...
	'Position',[378.75 378.0 45 15], ...
	'String',k22, ...
	'Style','edit', ...
	'Tag','EditText6');
my.objHandl(7) = uicontrol('Parent',my.objHandl(1), ...
	'Units','points', ...
    'BackgroundColor',[1 1 1], ...
  	'Callback','guifcn(3,[my.objHandl(7) my.objHandl(14)])',...
	'Position',[378.75 349.5 45 15], ...
	'String',F1, ...
	'Style','edit', ...
	'Tag','EditText3');
my.objHandl(8) = uicontrol('Parent',my.objHandl(1), ...
	'Units','points', ...
    'BackgroundColor',[1 1 1], ...
    'Callback','guifcn(3,[my.objHandl(8) my.objHandl(14)])',...
	'Position',[378.75 321.0 45 15], ...
	'String',F2, ...
	'Style','edit', ...
	'Tag','EditText1');
% delineation of the steady state water level
my.objHandl(9) = uicontrol('Parent',my.objHandl(1), ...
	'Units','points', ...
	'BackgroundColor',[0.7 0.7 0.7], ...
	'FontSize',10, ...
	'Position',[353.25 230.25 47.25 12.75], ...
	'String',h2s, ...
	'Style','text', ...
	'Tag','h2sresult');
my.objHandl(10) = uicontrol('Parent',my.objHandl(1), ...
	'Units','points', ...
	'BackgroundColor',[0.7 0.7 0.7], ...
	'FontSize',10, ...
	'Position',[353.25 259.5 47.25 12.75], ...
	'String',h1s, ...
	'Style','text', ...
    'Tag','h1sresult');
uicontrol('Parent',my.objHandl(1), ...
	'Units','points', ...
	'BackgroundColor',[0.75 0.75 0.75], ...
	'FontSize',10, ...
	'Position',[288.0 228.75 33.75 15], ...
	'String','h2s [m]', ...
	'Style','text', ...
	'Tag','hh2stext');
uicontrol('Parent',my.objHandl(1), ...
	'Units','points', ...
	'BackgroundColor',[0.75 0.75 0.75], ...
	'FontSize',10, ...
	'Position',[288.0 410.25 73.5 12.75], ...
	'String','k11 [m^2.5 h^-1]', ...
	'Style','text', ...
	'Tag','hk11text');
uicontrol('Parent',my.objHandl(1), ...
	'Units','points', ...
	'BackgroundColor',[0.75 0.75 0.75], ...
	'FontSize',10, ...
	'Position',[288.0 348.0 45.75 14.25], ...
	'String','F1 [m^2]', ...
	'Style','text', ...
	'Tag','hF1text');
uicontrol('Parent',my.objHandl(1), ...
	'Units','points', ...
    'BackgroundColor',[0.75 0.75 0.75], ...   
	'FontSize',10, ...
	'Position',[288.0 320.25 45.75 14.25], ...
	'String','F2 [m^2]', ...
	'Style','text', ...
	'Tag','hF2text');
uicontrol('Parent',my.objHandl(1), ...
	'Units','points', ...
	'BackgroundColor',[0.75 0.75 0.75], ...
	'FontSize',10, ...
	'Position',[288.0 378.75 73.5 12.75], ...
	'String','k22 [m^2.5 h^-1]', ...
	'Style','text', ...
	'Tag','hk22text');
uicontrol('Parent',my.objHandl(1), ...
	'Units','points', ...
	'BackgroundColor',[0.75 0.75 0.75], ...
	'FontSize',10, ...
	'Position',[288.0 258.75 35.25 14.25], ...
	'String','h1s [m]', ...
	'Style','text', ...
	'Tag','hh1stext');
 uicontrol('Parent',my.objHandl(1), ...
	'Units','points', ...
	'BackgroundColor',[0.75 0.75 0.75], ...
	'FontSize',10, ...
	'Position',[235.5 166.5 56.25 15.0], ...
	'String','Step time:', ...
	'Style','text', ...
	'Tag','steptitle');
uicontrol('Parent',my.objHandl(1), ...
	'Units','points', ...
	'BackgroundColor',[0.75 0.75 0.75], ...
	'FontSize',10, ...
	'Position',[309.75 167.25 27.75 15.0], ...
	'String','t [s]', ...
	'Style','text', ...
	'Tag','t_text');
my.objHandl(11) = uicontrol('Parent',my.objHandl(1), ...
    'Callback','guifcn(2,[my.objHandl(11) my.objHandl(14)])',...
	'Units','points', ...
    'BackgroundColor',[1 1 1], ...
	'Position',[374.25 167.25 45 15], ...
	'String',Stime, ...
	'Style','edit', ...
	'Tag','Edit_time');

uicontrol('Parent',my.objHandl(1), ...
	'Units','points', ...
	'BackgroundColor',[0.75 0.75 0.75], ...
	'FontSize',10, ...
	'Position',[231.75 140.25 68.25 15.0], ...
	'String','Initial value', ...
	'Style','text', ...
	'Tag','q0stitle');
uicontrol('Parent',my.objHandl(1), ...
	'Units','points', ...
	'BackgroundColor',[0.75 0.75 0.75], ...
	'FontSize',10, ...
	'Position',[261.75 121.5 72.0 13.5], ...
	'String','q0s [m^3 h^-1]', ...
	'Style','text', ...
	'Tag','q0stext');
my.objHandl(12) = uicontrol('Parent',my.objHandl(1), ...
	'Units','points', ...
    'BackgroundColor',[1 1 1], ...
	'Position',[374.25 123.75 45 15], ...
	'String',q0s, ...
    'Callback','guifcn(2,[my.objHandl(12) my.objHandl(14)])',...
	'Style','edit', ...
	'Tag','Edit_q0s');

uicontrol('Parent',my.objHandl(1), ...
	'Units','points', ...
	'BackgroundColor',[0.75 0.75 0.75], ...
	'FontSize',10, ...
	'Position',[231.75 98.25 68.25 15.0], ...
	'String','Final value', ...
	'Style','text', ...
	'Tag','q0title');
uicontrol('Parent',my.objHandl(1), ...
	'Units','points', ...
	'BackgroundColor',[0.75 0.75 0.75], ...
	'FontSize',10, ...
	'Position',[261.75 81.0 72.0 13.5], ...
	'String','q0 [m^3 h^-1]', ...
	'Style','text', ...
	'Tag','q0text');
my.objHandl(13) = uicontrol('Parent',my.objHandl(1), ...
	'Units','points', ...
    'Callback','guifcn(2,[my.objHandl(13) my.objHandl(14)])',...
    'BackgroundColor',[1 1 1], ...
	'Position',[374.25 80.25 45 15], ...
	'String',q0, ...    
	'Style','edit', ...
	'Tag','Edit_q0');

uicontrol('Parent',my.objHandl(1), ...
	'Units','points', ...
	'BackgroundColor',[0.75 0.75 0.75], ...
	'FontSize', 12, ...
    'FontWeight', 'demi', ...
	'Position',[276.0 489.75 166.5 16.5], ...
	'String','Two tanks system', ...
    'ForegroundColor', [0 0 0.541], ...
	'Style','text', ...
    'Tag','htitle');
uicontrol('Parent',my.objHandl(1), ...
	'Units','points', ...
	'BackgroundColor',[0.75 0.75 0.75], ...
	'FontSize',10, ...
	'ForegroundColor',[1 0 0], ...
	'Position',[234.75 57.0 93.75 12.0], ...
	'String','', ...
	'Style','text', ...
	'Tag','StarText*');
% pushbutton start
my.objHandl(14) = uicontrol('Parent',my.objHandl(1), ...
	'Units','points', ...
	'BackgroundColor',[0.75 0.75 0.75], ...
    'Callback','guifcn(4,[my.objHandl(12) my.objHandl(5) my.objHandl(6) my.objHandl(7) my.objHandl(8) my.objHandl(10) my.objHandl(9) my.objHandl(14) my.objHandl(4) my.objHandl(16) my.objHandl(15) my.textHandl(1:2) my.textHandl(3:5) my.objHandl(11) my.objHandl(13)])',...
	'Enable','on', ...
	'Position',[224.25 27.0 61.5 21.75], ...
	'String','Start', ...
    'Tag','Pushbutton1');
% pushbutton stop
my.objHandl(15) = uicontrol('Parent',my.objHandl(1), ...
	'Units','points', ...
	'BackgroundColor',[0.75 0.75 0.75], ...
    'Callback','guifcn(6,[my.objHandl(15) my.objHandl(14) my.objHandl(5) my.objHandl(6) my.objHandl(7) my.objHandl(8) my.objHandl(11) my.objHandl(12) my.objHandl(13)])',...
	'Enable','off', ...
	'Position',[298.5 27.0 61.5 21.75], ...
	'String','Pause', ...
    'Tag','Pushbutton2');
% pushbutton pause
my.objHandl(16) = uicontrol('Parent',my.objHandl(1), ...
	'Units','points', ...
	'BackgroundColor',[0.75 0.75 0.75], ...
    'Callback','guifcn(5,[my.objHandl(16) my.objHandl(14) my.objHandl(15) my.objHandl(5) my.objHandl(6) my.objHandl(7) my.objHandl(8) my.objHandl(11) my.objHandl(12) my.objHandl(13)])',...
	'Enable','off', ...
	'Position',[373.5 27.0 61.5 21.75], ...
	'String','Stop', ...
    'Tag','Pushbutton3');

uicontrol('Parent',my.objHandl(1), ...
	'Units','points', ...
	'BackgroundColor',[0.75 0.75 0.75], ...
	'FontSize',10, ...
	'Position',[278.25 462.0 170 12.0], ...
	'String','Parameters of the tanks system:', ...
    'FontWeight', 'demi', ...
	'Style','text', ...
    'Tag','StaticText23');
uicontrol('Parent',my.objHandl(1), ...
	'Units','points', ...
	'BackgroundColor',[0.75 0.75 0.75], ...
	'FontSize',10, ...
	'Position',[278.25 287.25 140 12.0], ...
	'String','Steady state water levels:', ...
    'FontWeight', 'demi', ...
	'Style','text');
uicontrol('Parent',my.objHandl(1), ...
	'Units','points', ...
	'BackgroundColor',[0.75 0.75 0.75], ...
	'FontSize',10, ...
	'Position',[209.25 194.25 122.75 12.0], ...
	'String','Step parameters:', ...
    'FontWeight', 'demi', ...
	'Style','text');

axes(my.objHandl(2));
draw_background('begin');

handle_t1 = zeros(1,2);
handle_t2 = zeros(1,3);

my.tag = {'h1s =' 'h2s =' ''; 'nh1' 'nh2' ''; 'nq0' 'nq1' 'nq2'; 'q0s =' 'q1(t) =' 'q2(t) ='};

for i = 1 : 2,
    % object which display the  actual water level
    % 1.25
    handle_t1(i) = text('Parent', my.objHandl(2), ...
        'Position', [bg.X_t1(i) bg.Y_t(i) 0], ...
        'Color', [0 0.3 0.8], ...
        'EraseMode', ' background', ...
        'FontAngle', 'italic', ...
        'FontSize', 8.5, ...
        'HorizontalAlignment','left', ...
        'String', '0.00', ...
        'Tag', my.tag{2,i});

    % h1s(t) = ...
    text('Parent', my.objHandl(2), ...
        'Position', [bg.X_t2(i) bg.Y_t(i) 0], ...
        'Color', [0 0.3 0.8], ...
        'EraseMode', 'background', ...
        'FontAngle', 'italic', ...
        'FontSize',8.5, ...
        'String', my.tag{1,i}, ...
        'Tag', my.tag{1,i});
end

for i = 1 : 3,
    % object which display the actual water flow
    handle_t2(i) = text('Parent', my.objHandl(2),...
        'EraseMode', 'background', ...
        'HorizontalAlignment','left', ...
        'FontAngle', 'italic', ...
        'FontSize', 8.5, ...
        'Position', [bg.X_t3(i) bg.Y_t3(i) 0], ...
        'String', '0.00', ...
        'Tag', my.tag{3,i});

    % q0s= q1(t)=
    text('Parent', my.objHandl(2), ...
        'Position', [bg.X_t4(i) bg.Y_t3(i) 0], ...
        'EraseMode', 'background', ...
        'FontAngle', 'italic', ...
        'FontSize',8.5, ...
        'String', my.tag{4,i}, ...
        'Tag', my.tag{4,i});
end
my.textHandl = [handle_t1 handle_t2];

clear i handle_t1 handle_t2;

grid(my.objHandl(3));
% --------
