%
% Volanie callback funkcii pri aktivacii jednotlivych
% editovacich policok a tlacidiel GUI okna
% Tatiana Lipnicanova
% marec 2004
%
function guifcn(action,handles)

global Stime q0s q0 k11 k22 F1 F2 h1s h2s A B C D intr
global h1s_q0 h2s_q0

switch(action)
    
    case 1
        set(handles(1),'Enable','on')
        
    case 2
        if str2num(get(handles(1),'String')) < 0
            set(handles(1),'String','? ? ?')
            h = findobj(gcbf,'Tag','StarText*');
            set(h,'String','* incorrect parameter')
            set(handles(2),'Enable','off')
        elseif size(findobj('String','? ? ?'),1) == 0
            h = findobj(gcbf,'String','* incorrect parameter');
            set(h,'String','')
            set(handles(2),'Enable','on')
        end
        
    case 3
        if str2num(get(handles(1),'String')) <= 0
            set(handles(1),'String','? ? ?')
            set(findobj(gcbf,'Tag','StarText*'),'String','* incorrect parameter')
            set(handles(2),'Enable','off');
        elseif isempty(findobj('String','? ? ?'))
            set(findobj(gcbf,'String','* incorrect parameter'),'String','')
            set(handles(2),'Enable','on')
        end

    case 4
        Stime = str2num(get(handles(17),'String'));
        q0 = str2num(get(handles(18),'String'));
        q0s = str2num(get(handles(1),'String'));
        k11 = str2num(get(handles(2),'String'));
        k22 = str2num(get(handles(3),'String'));
        F1 = str2num(get(handles(4),'String'));
        F2 = str2num(get(handles(5),'String'));
        intr = get(handles(9),'Value');
        
        if  strcmp(get(handles(8),'String'),'Start') == 1
            set(handles(12),'String', '0.00')
            set(handles(13),'String', '0.00')
            set(handles(14),'String', sprintf('%.2f', q0s))
            set(handles(15),'String', '0.00')
            set(handles(16),'String', '0.00')
            set(findobj('String','q0(t) ='),'String','q0s =')
            
            % Calculate equilibrium point
            [h1s,h2s]=tankeqpoint(q0s,k11,k22,F1,F2,intr);
            if q0 ~= q0s
                [h1s_q0,h2s_q0]=tankeqpoint(q0, k11, k22, F1, F2, intr);
            else
                h1s_q0 = [];
                h2s_q0 = [];
            end        
            set(handles(6),'String',sprintf('%.2f',h1s))
            set(handles(7),'String',sprintf('%.2f',h2s))
            
            % Calculate the matrices in a linearized state space model
            [A,B,C,D] = tanklin(q0s,h1s,h2s,k11,k22,F1,F2,intr);
            
            set(findobj('Tag','graphL'),'XLim',[0 5])
            set(handles(8),'Enable','off')
            set(handles(10),'Enable','on')
            set(handles(11),'Enable','on')
            
            axes(findobj('Tag','picture'))

            tags = {'nh1' 'nh2' 'nq0' 'nq1' 'nq2' 'h1s =' 'h2s =' 'q0s =' 'q1(t) =' 'q2(t) ='};
            safe_h = zeros(size(tags));
            for j = 1:size(tags,2)
                safe_h(j) = findobj('Tag',tags{j});
                set(safe_h(j),'HandleVisibility','off')
            end
            cla
            set(safe_h,'HandleVisibility','on')

            draw_background('begin');
            % mozno to ani netreba
            
            axes(findobj('Tag','graphL'))
            cla
            
            % simulation
            set_param('watertanks', 'SimulationCommand', 'start')
                       
        else
            set_param('watertanks', 'SimulationCommand', 'continue')
            set(handles(8),'String','Start');
            set(handles(8),'Enable','off');
        end
        
    case 5
        set_param('watertanks', 'SimulationCommand', 'stop')
        if strcmp(get(handles(2),'String'),'Start') == 0
            set(handles(2),'String','Start')
        end
        set(handles(1),'Enable','off')
        set(handles(2),'Enable','on')
        set(handles(3),'Enable','off')

        if ~isempty(findobj('Tag','unchangeable'))
            set(findobj('Tag','unchangeable'),'Style','edit','Tag','changeable')
        end
        
    case 6
        set(handles(1),'Enable','off')
        set_param('watertanks', 'SimulationCommand', 'pause')
        set(handles(2),'String','Continue')
        set(handles(2),'Enable','on')

        if  isempty(findobj('Tag','unchangeable'))
            set(handles(3:9),'Style','text','Tag','unchangeable')
        end
        
    otherwise
        disp('*** Wrong argument is call o function guifcn ***')
end