%
% S-funkcia systemu zasobnikov kvapaliny
% Tatiana Lipnicanova
% marec 2004
%
function [sys,x0] = tanks_sfcn(t,x,u,flag,k11,k22,F1,F2,intr)
global h1s h2s

if flag == 0,
    sys = [2,0,2,1,0,0];
    x0 = [h1s h2s];
    
elseif flag == 1,
    if x(1) < 0 x(1) = 0; end
    if x(2) < 0 x(2) = 0; end
    
    switch intr
        case 0
            dxdt(1) = (1/F1)*(u - k11*sqrt(x(1)));
            dxdt(2) = (1/F2)*(k11*sqrt(x(1)) - k22*sqrt(x(2)));
        case 1,
            if (x(2) > x(1))
                x(2)=x(1);
            end
            dxdt(1) = (1/F1)*(u - k11*sqrt(x(1)-x(2)));
            dxdt(2) = (1/F2)*(k11*sqrt(x(1)-x(2)) - k22*sqrt(x(2)));
    end
    sys = dxdt;
    
elseif flag == 3,
    if (x(1)<0) x(1)=0; end
    if (x(2)<0) x(2)=0; end
    if (x(2) > x(1) & intr == 1 ) x(2)=x(1); end
    sys = x;
    
else
    sys = [];
end
