%
% Vypocet ustalenych vysok kvapaliny
% Tatiana Lipnicanova
% marec 2004
%
function [x1,x2] = tankeqpoint(q,k11,k22,F1,F2,intr)
% the computation of stationary points

switch intr
    case 0
        % the stationary water levels of tanks without interaction
        x = [(q/k11)^2 ((q/k11)^2*(k11/k22)^2)];
        
    case 1
        % with interaction
        Z = [ 1 -1 ; 1 -((k22/k11)^2+1)];
        Y = [(q/k11)^2 ; 0];
        x = (Z\Y)';
end

x1 = x(1);
x2 = x(2);
