%
% Vypocet matic linearneho stavoveho opisu
% Tatiana Lipnicanova
% marec 2004
%
function [A,B,C,D] = tanklin(q,h1s,h2s,k11,k22,F1,F2,intr)
% matrices of state space
 
switch intr
    case 0  % without interaction
        if q == 0
            K1 = 0;
            K2 = 0;
        else
            K1 = k11/(2*sqrt(h1s));
            K2 = k22/(2*sqrt(h2s));
        end
        A = [ -(K1/F1) 0 ; (K1/F2) -(K2/F2) ];       

    case 1  % with interaction
        if q == 0
            K1 = 0;
            K2 = 0;
        else
            K1 = k11/(2*sqrt(h1s-h2s));
            K2 = k22/(2*sqrt(h2s));
        end
        A = [ -(K1/F1) (K1/F1) ; (K1/F2) -((K1+K2)/F2) ];
end

B = [ (1/F1) ; 0 ];
C = eye(2);
D = zeros(2,1); 