function  [sys, x0] = hs2(t,x,u,flag,kk,ff,hh,inter)
%HS2   Dva zasobniky bez interakcie (inter=0), alebo s interakciou (inter<>0)
% parametre: kk[. .], ff[. .], hh[. .], inter={0|1}

if abs(flag) == 1
  if (x(1)<0 ) x(1)=0; end
  if (x(2)<0 ) x(2)=0; end
  if inter == 0
    sys(1) = (u  - kk(1) * sqrt(x(1)) )/ff(1);
    sys(2) = (kk(1) * sqrt(x(1))  - kk(2) * sqrt(x(2)) )/ff(2);
  else
    if ( x(2) > x(1) ) x(2)=x(1); end
    sys(1) = (u  - kk(1) * sqrt(x(1)-x(2)) )/ff(1);
    sys(2) = (kk(1) * sqrt(x(1)-x(2))  - kk(2) * sqrt(x(2)) )/ff(2);
  end

elseif flag == 3
  if (x(1)<0 ) x(1)=0; end
  if (x(2)<0 ) x(2)=0; end
  if (x(2) > x(1) & inter ~= 0 ) x(2)=x(1); end
  sys = x;
  
elseif flag  == 0
  sizes=zeros(1,6);
  % sizes(1) = number of continuous states
  sizes(1) = 2;
  % sizes(2) = number of discrete states
  sizes(2) = 0;
  % sizes(3) = number of system outputs (length of output y)
  sizes(3) = 2;
  % sizes(4) = number of system inputs (length of input u)
  sizes(4) = 1;
  % sizes(5) = number of discontinuous roots; unused feature, set to zero
  sizes(5) = 0;
  % sizes(6) = direct feedthrough flag; used to detect algebraic loops.
  % Set sizes(6) to 1 if the output y depends directly on the input u.
  % Otherwise, it should be set to 0.
  sizes(6) = 0;
  % Set the initial conditions on the states
  x0 = hh;
  sys = sizes';

else 
  sys = [];

end

